#include <stdio.h>
#include <math.h>
#include <time.h>
#include "path.h"

Sys                    sys;
Slice                  *slice,*trial,*seq_1,*seq_2;
Path                   path;
Langevin               langevin;
Stats                  nulstat ={0};
vector                 nulvec  ={0};
Scr                    scr,nulscr  ={0};
Bivar                  bivar;


void print_header       (); 
void new_conf           ();
void langevin_init();
void set_up()
{ 
  long itime;
  int i,j;
  double x;


  input("path.inp");

  seq_1  = (Slice*)calloc(path.nslices,sizeof(Slice));
  seq_2  = (Slice*)calloc(path.nslices,sizeof(Slice));
  path.which_array =0;
  slice = (path.which_array) ? seq_1 : seq_2;

  if (sys.start_type ==1) { 
    confinput(); 
  }
  if (sys.start_type ==0) { 
    new_conf();
  }
 


  sys.norm = sqrt(PI*PI*PI)*sys.sigma*sys.sigma*sys.sigma;
  sys.bDdt = sys.beta*sys.sigma*sys.sigma/2;
  langevin_init();

  slice[0].x =sys.initx;
  slice[0].y =sys.inity;
  slice[0].energy= energy(&slice[0]);
  gprint(sys.bDdt);
  
  path.final = path.initial=nulvec;
  path.initial.x =-0.5;
  path.final.x =0;
  path.final.y =0;
  path.initial.y =0.5;

  
  sys.saddlex = -1.95783;
  sys.saddley =  1.95947;
  
  path.lower_bound_A *= PI/180;
  path.upper_bound_A *= PI/180;
  path.lower_bound_B *= PI/180;
  path.upper_bound_B *= PI/180;

  for(i=0;i<path.nslices;i++) {
    if (in_stable_state_B(&slice[i])) {
      path.hbfirst = i;
      break;
    }
  }
  dprint(path.hbfirst);
  
  print_header();
  scr =nulscr;
  return;
}

void langevin_init()
{
  double fdt,ex,temp,dt,s11,s22,s12,S;
  
  dt = sys.dt;
  fdt = sys.dt * langevin.gamma;
  ex  = exp (-fdt);
  temp = 1./sys.beta;

  bivar.sig_r = dt * dt * temp * (2. - (3. - 4.*ex + ex*ex)/fdt ) / fdt;
  bivar.sig_v = temp * (1.0 - ex * ex);

  bivar.sig_r = sqrt(bivar.sig_r);
  bivar.sig_v = sqrt(bivar.sig_v);

  bivar.c_rv  = dt * temp * (1.0 - ex) * (1.0 - ex) / fdt /  bivar.sig_r / bivar.sig_v;
  bivar.sigma = 0.5 / (1.0 - bivar.c_rv * bivar.c_rv);
  bivar.norm  = 1.0 / sqrt (2.0 * PI * bivar.sig_r * bivar.sig_v *
			    sqrt (1.0 - bivar.c_rv * bivar.c_rv));

  s11 = bivar.sig_r * bivar.sig_r;
  s22 = bivar.sig_v * bivar.sig_v;
  s12 = bivar.c_rv * bivar.sig_r * bivar.sig_v;
  S   = s11 * s22 - s12 * s12;
  bivar.s12os11 = s12 / s11; 
  bivar.sqrts11   = sqrt(s11);
  bivar.sqrtSos11 = sqrt(S/s11);

  langevin.c0 =ex;
  langevin.c1 =(1-langevin.c0)/fdt;
  langevin.c2 =(1-langevin.c1)/fdt;
  if (langevin.gamma==0) {
     langevin.c0 =1;
     langevin.c1 =1;
     langevin.c2 =0.5;
   }
  langevin.c1min2 = langevin.c1-langevin.c2;

  

}


int input(char name[])
{

  char dum[40];
  FILE *fp;
  int i,idum;

  if ((fp = fopen(name,"r"))==NULL){
    printf("input: can't open %s\n",name);
    return 1;
  } else {
    fscanf(fp,"%s",dum ); 
    fscanf(fp,"%d%s",&sys.sim_type,dum );
    fscanf(fp,"%d%s",&sys.start_type,dum );
    fscanf(fp,"%d%s",&sys.ncycle1,dum );
    fscanf(fp,"%d%s",&sys.ncycle2,dum ); 
    fscanf(fp,"%d%s",&sys.nshoot,dum );
    fscanf(fp,"%d%s",&sys.nrept,dum ); 
    fscanf(fp,"%d%s",&sys.ndif,dum ); 
    fscanf(fp,"%lf%s",&sys.beta,dum );
    fscanf(fp,"%lf%s",&sys.dt,dum ); 
    fscanf(fp,"%lf%s",&langevin.gamma,dum );
    fscanf(fp,"");
    fscanf(fp,"%d%s",&sys.freq_check,dum );
    fscanf(fp,"%d%s",&sys.freq_graphics,dum );
    fscanf(fp,"");
    fscanf(fp,"%s",dum );
    fscanf(fp,"%d%s",&sys.npart,dum );
    fscanf(fp,"%d%s",&path.nslices,dum );
    fscanf(fp,"%lf%s",&sys.initx,dum );
    fscanf(fp,"%lf%s",&sys.inity,dum );
    fscanf(fp,"%lf%s",&sys.sigma,dum );
    fscanf(fp,"%lf%s",&path.lower_bound_A,dum );
    fscanf(fp,"%lf%s",&path.upper_bound_A,dum );
    fscanf(fp,"%lf%s",&path.lower_bound_B,dum );
    fscanf(fp,"%lf%s",&path.upper_bound_B,dum );
    fscanf(fp,"%d%s",&path.endpoint_constrained,dum );
    

    sys.block_stats.aver[0].name = "potential energy  ";  
    sys.block_stats.aver[1].name = "kinetic   energy   ";
    sys.block_stats.aver[2].name = "total     energy   ";
    sys.block_stats.aver[3].name = "temp first slice   ";
    sys.block_stats.aver[4].name = "temp last  slice   ";
    sys.block_stats.aver[5].name = "hahb               ";
    sys.block_stats.aver[6].name = "dhb               ";
    sys.block_stats.aver[7].name = "number of blips   ";

    sys.block_stats.shoot[0].name = "no slices in A     ";
    sys.block_stats.shoot[1].name = "no slices in B     ";
    sys.block_stats.shoot[2].name = "no slices barrier  ";
    sys.block_stats.shoot[3].name = "no forward moves   ";
    sys.block_stats.shoot[4].name = "no backward moves  ";
    sys.block_stats.shoot[5].name = "no diffusion moves ";
    sys.block_stats.shoot[6].name = "no left shifts     ";
    sys.block_stats.shoot[7].name = "no right shifts    ";
    sys.block_stats.shoot[8].name = "initial distance   ";
    sys.block_stats.shoot[9].name = "final distance    ";


    sys.block_stats.mcacc[0].name= "forward shoots  ";
    sys.block_stats.mcacc[1].name= "backward shoots ";
    sys.block_stats.mcacc[2].name= "left  shifts    ";
    sys.block_stats.mcacc[3].name= "right shifts    ";
    sys.block_stats.mcacc[4].name= "left  diffusion ";
    sys.block_stats.mcacc[5].name= "right diffusion ";
    sys.block_stats.mcacc[6].name= "endpoints in B  ";
  


    nulstat=sys.final_stats =sys.block_stats ;

  }
  return;
}


void print_header()
{
  printf("DYNAMICAL SAMPLING OF LANGEVIN ACTION IN 2D POTENTIAL\n\n");
  printf("Peter Bolhuis 1999\n\n");
  printf("SYSTEM PARAMETERS\n\n");
  printf("Number of particles                %12d\n",sys.npart);
  printf("Friction                           %12g\n",langevin.gamma);
  printf("Temperature (beta)                 %12g\n",sys.beta);
  printf("Langevin timestep                  %12g\n",sys.dt);
  printf("Integration step bDdt              %12g\n",sys.bDdt);
  printf("Sigma_r                            %12g\n",bivar.sig_r);
  printf("Sigma_v                            %12g\n",bivar.sig_v);
  printf("c_rv                               %12g\n",bivar.c_rv);
  printf("c0                                 %12g\n",langevin.c0);
  printf("c1                                 %12g\n",langevin.c1);
  printf("c2                                 %12g\n",langevin.c2);

  printf("\nPATH PARAMETERS\n\n");
  printf("Number of timesteps                %12d\n",path.nslices);

  printf("Initial total energy               %12g\n",path.energy);
  printf("Sigma of springs                   %12g\n",sys.sigma);


  printf("\nSIMULATION PARAMETERS\n\n");
  
  printf(((sys.start_type == 0) ? "starting from random configuration" : 
	  "Read configuration from file fluid.inp"));
  printf("  -  istart = %d\n",sys.start_type);
  printf("Number of simulation blocks        %12d\n",sys.ncycle1);
  printf("Number of cycles per block         %12d\n",sys.ncycle2);
  printf("Total number of cycles             %12d\n",sys.ncycle1*sys.ncycle2);
  
  printf("Frequency of check                 %12d\n",sys.freq_check);
  printf("Frequency of path dump             %12d\n",sys.freq_dump);
  printf("Frequency of graphics              %12d\n",sys.freq_graphics);
  
  
  

}



void new_conf()
{
  int i;
 
  sys.energy =0;

  for(i=0;i<path.nslices;i++){
    slice[i].x = 1.8*((double)i/(path.nslices-1) -0.5);
    slice[i].y=sin(PI*i/(path.nslices-1))*1;
    sys.energy+= energy(&slice[i]);
  }
  /*  for(i=1;i<path.nslices;i++) slice[i] = slice[0];*/
  return;
}

void confinput()
{
  char dum[40];
  FILE *fp;
  int i; 
  
  if ((fp = fopen("fluid.inp","r"))==NULL){
    printf("inpput: can't open fluid.inp\n");
    return;
  } else {
    fscanf(fp,"%d %s",&path.nslices,dum); 


    for(i=0;i<path.nslices;i++) {
      fscanf(fp,"%lf %lf",&slice[i].x,&slice[i].y);
    }
    fclose(fp);
  }

}

void confoutput()
{
  FILE *fp;
  int i; 
  
  if ((fp = fopen("fluid.out","w"))==NULL){
    printf("output: can't open fluid.out\n");
    return;
  } else {
    fprintf(fp,"%d  particles \n",path.nslices); 
    for(i=0;i<path.nslices;i++) {
      fprintf(fp,"%lf %lf\n",slice[i].x,slice[i].y);
    }
    fclose(fp);
  }
}



void distoutput()

{
  FILE *fp;
  double x,y[4];
  int i; 
  
  if ((fp = fopen("energy.dat","w"))==NULL){
    printf("output: can't open energy.dat\n");
    return;
  } else {
    for(i=0;i<path.nslices;i++) {
      gprint(scr.energy[i]);
      scr.energy[i] /= sys.ncycle1*sys.ncycle2;
      scr.energy2[i] = scr.energy2[i] /(sys.ncycle1*sys.ncycle2) - scr.energy[i]*  scr.energy[i];
      scr.energy2[i] = (scr.energy2[i]>0) ? sqrt(scr.energy2[i]) : 0;
      scr.free_en[i] =-log(scr.free_en[i] /scr.fcount);
      if (i==0) { 
	scr.free_en[0] =0 ;
      } else scr.free_en[i] += scr.free_en[i-1];
            
      fprintf(fp,"%d %lf %lf\n",i,scr.energy[i],scr.energy2[i]);
    }
    fclose(fp);
  }
  if ((fp = fopen("hahb.dat","w"))==NULL){
    printf("output: can't open energy.dat\n");
    return;
  } else {
    for(i=0;i<path.nslices;i++) {
      scr.hahb[i]/=scr.n;
      scr.hadhb[i]/=scr.n;
      scr.haHb[i]/=scr.n;
      fprintf(fp,"%d %lf %lf %lf\n",i,scr.hahb[i],scr.haHb[i],scr.hadhb[i]);
    }
    fclose(fp);
  }
  if ((fp = fopen("flux.dat","w"))==NULL){
      printf("output: can't open energy.dat\n");
      return;
    } else {
      for(i=0;i<path.nslices;i++) {
	scr.blip[i]/=scr.n;
	if (scr.navb[i]>0) {
	  scr.dHaHbt[i] /=scr.navb[i];
	  scr.dHahbt[i] /=scr.navb[i];
	}
	if (scr.nava[i]>0) {
	  scr.dHaHat[i] /=scr.nava[i];
	  scr.dHahat[i] /=scr.nava[i];
	}
	fprintf(fp,"%d %lf %lf %lf %lf %lf\n",i,scr.blip[i],scr.dHaHbt[i],scr.dHahbt[i],
		scr.dHaHbt[i],scr.dHahbt[i]);
    }
    fclose(fp);
  }

   
  if ((fp = fopen("acc.dat","w"))==NULL){
      printf("output: can't open acc.dat\n");
      return;
    } else {    
      for(i=0;i<path.nslices;i++) {
        fprintf(fp,"%d %d %d %d %d\n",i,scr.pfacc[i],scr.pbacc[i],scr.placc[i],
		scr.pracc[i]);
      }
      fprintf(fp,"*\n");
      for(i=0;i<path.nslices;i++) {
        fprintf(fp,"%d %d %d %d %d\n",i,scr.pftry[i],scr.pbtry[i],scr.pltry[i],
		scr.prtry[i]);
      }
      fprintf(fp,"*\n");
      for(i=0;i<path.nslices;i++) {
        y[0] = (scr.pftry[i]>0) ?  (double)scr.pfacc[i]/scr.pftry[i] : 0;
        y[1] = (scr.pbtry[i]>0) ?  (double)scr.pbacc[i]/scr.pbtry[i] : 0;
        y[2] = (scr.pltry[i]>0) ?  (double)scr.placc[i]/scr.pltry[i] : 0;
        y[3] = (scr.prtry[i]>0) ?  (double)scr.pracc[i]/scr.prtry[i] : 0;

        fprintf(fp,"%d %lf %lf %lf %lf\n",i,y[0],y[1],y[2],y[3]);
      }
    }



  
  if ((fp = fopen("xdist.dat","w"))==NULL){
    printf("output: can't open energy.dat\n");
    return;
  } else {
    for(i=0;i<MBIN;i++){
      x = 0.01*(i-MBIN/2);
      fprintf(fp,"%lf %lf %lf\n",x,scr.xdist[i], scr.ydist[i]);
    }
    fclose(fp);
  }
  if ((fp = fopen("endpdist.dat","w"))==NULL){
    printf("output: can't open energy.dat\n");
    return;
  } else {
    for(i=0;i<MBIN;i++){
      x = i-90;
      fprintf(fp,"%lf %d\n",x,scr.endpointdist[i]);
    }
    fclose(fp);
  }
      
  
  
}



