# include <X11/Xlib.h>
# include <X11/Xutil.h>
# include <X11/Xos.h>
# include <X11/Xatom.h> 
# include <stdio.h>
# include <stdlib.h>
# include <math.h>
# include <limits.h>
# include "path.h"

/* various window stuff */
Display *display;
int screen;
Window window,quitbutton,pausebutton,algobutton,heatwindow,boundwindow,about;
GC gc, gcr, gcxor, gccolor;
XImage *spinimage,*clusterimage;
XFontStruct *font=NULL;
int font_height;
unsigned int windowwidth, windowheight;
XSizeHints size_hints;

void drawline(vector r1, vector r2)

{
  int x1,y1,x2,y2,scale;
  
  scale =50;
  x1 = r1.x * scale + windowwidth/2;
  y1 = r1.y * scale + windowheight/2;
  x2 = r2.x * scale + windowwidth/2;
  y2 = r2.y * scale + windowheight/2;
  XDrawLine(display,window,gc,x1,y1,x2,y2); 
  XFlush(display);
  return;
}

void plot_conf()
{
 
  int x1,x2,y1,y2,x3,y3,i,width,height,scale;
  double r,x,y,cosa,sina;

  scale=50;
  XClearArea(display, window, 0,0, windowwidth, windowheight,0);     
  /* for(i=-10;i<=10;i+=2) {
    x1 =i*10 + windowwidth/2;
    XDrawLine(display,window,gc,x1,0,x1,windowheight);
    }*/
  /*
  x = -3;
  y= path.upper_angle_A - x;
  x1 = x*scale + windowwidth/2 ; 
  y1 = y*scale + windowheight/2;
  x =3;
  y= path.upper_angle_A - x;
  x2 = x*scale + windowwidth/2 ; 
  y2 = y*scale + windowheight/2;
  XDrawLine(display,window,gc,x1,y1,x2,y2);
  x = -3;
  y= path.inner_ring_dist - x;
  x1 = x*scale + windowwidth/2 ; 
  y1 = y*scale + windowheight/2;
  x =3;
  y= path.inner_ring_dist - x;
  x2 = x*scale + windowwidth/2 ; 
  y2 = y*scale + windowheight/2;
  XDrawLine(display,window,gc,x1,y1,x2,y2);
  x = -3;
  y= path.outer_ring_dist - x;
  x1 = x*scale + windowwidth/2 ; 
  y1 = y*scale + windowheight/2;
  x =3;
  y= path.outer_ring_dist - x;
  x2 = x*scale + windowwidth/2 ; 
  y2 = y*scale + windowheight/2;
  XDrawLine(display,window,gc,x1,y1,x2,y2);
  */

  
  x1 = path.final.x*scale + windowwidth/2 ; 
  y1 = path.final.y*scale + windowheight/2;
  r= 3;
  cosa= cos(path.lower_bound_B);
  sina= sin(path.lower_bound_B);
  y = r*sina;
  x = r*cosa;
  x2 = x1 +x*scale;
  y2 = y1 +y*scale;
  XDrawLine(display,window,gc,x1,y1,x2,y2);
  r= 3; 
  cosa= cos(path.upper_bound_B);
  sina= sin(path.upper_bound_B);
  y = r*sina;
  x = r*cosa;
  x3 = x1 +x*scale;
  y3 = y1 +y*scale;
  XDrawLine(display,window,gc,x1,y1,x3,y3);
  /*  XDrawLine(display,window,gc,x2,y2,x3,y3);*/
  width  =r*scale;
  height = r*scale;
  XDrawArc(display, window, gc, x1-width,y1-height,2*width, 2*height,
	   (-path.upper_bound_B*(180/PI))*64,
	   ((path.upper_bound_B-path.lower_bound_B)*(180/PI))*64);
  
  x1 = path.initial.x*scale + windowwidth/2 ; 
  y1 = path.initial.y*scale + windowheight/2;
  r= 3;
  cosa= cos(path.lower_bound_A);
  sina= sin(path.lower_bound_A);
  y = r*sina;
  x = r*cosa;
  x2 = x1 +x*scale;
  y2 = y1 +y*scale;
  XDrawLine(display,window,gc,x1,y1,x2,y2);
  r= 3; 
  cosa= cos(path.upper_bound_A);
  sina= sin(path.upper_bound_A);
  y = r*sina;
  x = r*cosa;
  x3 = x1 +x*scale;
  y3 = y1 +y*scale;
  XDrawLine(display,window,gc,x1,y1,x3,y3);
  /*  XDrawLine(display,window,gc,x2,y2,x3,y3);*/
  width  =r*scale;
  height = r*scale;
  XDrawArc(display, window, gc, x1-width,y1-height,2*width, 2*height,
	   (360-path.upper_bound_A*(180/PI))*64,
	   ((path.upper_bound_A-path.lower_bound_A)*(180/PI))*64);
  

  /*  x1 = path.final.x * scale + windowwidth/2;
  y1 = path.final.y   * scale + windowheight/2;
  width  = path.inner_ring_dist * scale;
  height = path.inner_ring_dist * scale;
  XDrawArc(display, window, gc, x1-width, y1-height, 2*width, 2*height, 0,360*64);
  width  = path.outer_ring_dist * scale;
  height = path.outer_ring_dist * scale;
  XDrawArc(display, window, gc, x1-width, y1-height, 2*width, 2*height, 0,360*64);
  */
  /*
  x1 = path.initial.x * scale + windowwidth/2;
  y1 = path.initial.y   * scale + windowheight/2;
  width  = path.width_constraint * scale;
  height = path.width_constraint * scale;
  XDrawArc(display, window, gc, x1-width, y1-height, 2*width, 2*height, 0,360*64);
  */
  /*  x1 = path.initial.x * scale + windowwidth/2;
  y1 = path.initial.y   * scale + windowheight/2;
  width  = path.excluded_regionA_dist * scale;
  height = path.excluded_regionA_dist * scale;
  XDrawArc(display, window, gc, x1-width, y1-height, 2*width, 2*height, 0,360*64);
  */

  x1 = slice[0].x * scale + windowwidth/2;
  y1 = slice[0].y * scale + windowheight/2;
  for(i=1;i<path.nslices;i++) {
    x2 = slice[i].x * scale + windowwidth/2;
    y2 = slice[i].y * scale + windowheight/2;
    XDrawLine(display,window,gc,x1,y1,x2,y2);
    x1 =x2;
    y1 =y2;
  }
  x1 = 0;
  y1 = energy(&slice[0]);
  for(i=1;i<path.nslices;i++) {
    x2 = i;
    y2 = energy(&slice[i]);
    XDrawLine(display,window,gc,x1,y1,x2,y2);
    x1 =x2;
    y1 =y2;
  }
  x1 = slice[0].x * scale + windowwidth/2;
  y1 = windowheight-2*energy(&slice[0]);
  for(i=1;i<path.nslices;i++) {
    x2 = slice[i].x * scale + windowwidth/2;
    y2 = windowheight-2*energy(&slice[i]);
    XDrawLine(display,window,gc,x1,y1,x2,y2);
    x1 =x2;
    y1 =y2;
  }
    

  x1 = sys.saddlex * scale + windowwidth/2 -10;
  y1 = sys.saddley * scale + windowheight/2 -10;
  x2 = sys.saddlex * scale + windowwidth/2 +10;
  y2 = sys.saddley * scale + windowheight/2 +10;
  XDrawLine(display,window,gc,x1,y1,x2,y2);

  x1 = sys.saddlex * scale + windowwidth/2 -10;
  y1 = sys.saddley * scale + windowheight/2 +10;
  x2 = sys.saddlex * scale + windowwidth/2 +10;
  y2 = sys.saddley * scale + windowheight/2 -10;
  XDrawLine(display,window,gc,x1,y1,x2,y2);

  
  XFlush(display);
  
  return;
}

void init_graphics() 
{
  int argc =0;
  char **argv;
  char *progname="progamme";
  char *window_name="Simulation";
  char *icon_name="Sim";
  Pixmap icon_pixmap;
  char *display_name=NULL;
  long event_mask;
  XColor xcolor,colorcell;
  Colormap cmap;
  int depth,darkcolor,lightcolor;

#define icon_bitmap_width 16
#define icon_bitmap_height 16
 static char icon_bitmap_bits[] = {
   0x1f, 0xf8, 0x1f, 0x88, 0x1f, 0x88, 0x1f, 0x88, 0x1f, 0x88, 0x1f, 0xf8,
   0x1f, 0xf8, 0x1f, 0xf8, 0x1f, 0xf8, 0x1f, 0xf8, 0x1f, 0xf8, 0xff, 0xff,
   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff};

/* open up the display */
 if ((display=XOpenDisplay(display_name))==NULL)
  {fprintf(stderr,"Error: cannot connect to X server %s\n",
    XDisplayName(display_name));
   exit(-1);
  }
 screen=DefaultScreen(display);

 depth=DefaultDepth(display,screen);
 cmap=DefaultColormap(display,screen);

 darkcolor=BlackPixel(display,screen);
 lightcolor=WhitePixel(display,screen);
 if (depth>1) /* color? This is not the right way to do it, but .... */
  {if (XAllocNamedColor(display,cmap,"black",&colorcell,&xcolor))
              darkcolor=colorcell.pixel;
   if (XAllocNamedColor(display,cmap,"cornsilk",&colorcell,&xcolor))
              lightcolor=colorcell.pixel;
  }

/* make the main window */

 windowwidth=windowheight=400;
 window=XCreateSimpleWindow(display,RootWindow(display,screen),
   0,0,windowwidth,windowheight,4,BlackPixel(display,screen),
   lightcolor);

/* make the icon */
 icon_pixmap=XCreateBitmapFromData(display,window,
   icon_bitmap_bits,icon_bitmap_width,
   icon_bitmap_height);

 size_hints.flags=PPosition | PSize | PMinSize;
 size_hints.min_width=windowwidth;
 size_hints.min_height=windowheight;
#ifdef X11R3
 size_hints.x=x;
 size_hints.y=y;
 size_hints.width=windowwidth;
 size_hints.height=windowheight;
 XSetStandardProperties(display,window,window_name,icon_name,
    icon_pixmap,argv,argc,&size_hints);
#else
 {XWMHints wm_hints;
  XClassHint class_hints;
  XTextProperty windowName, iconName;
  if (XStringListToTextProperty(&window_name,1,&windowName)==0)
   {fprintf(stderr,"%s: structure allocation for windowName failed.\n"
      ,progname);
    exit(-1);
   }
  if (XStringListToTextProperty(&icon_name,1,&iconName)==0)
   {fprintf(stderr,"%s: structure allocation for iconName failed.\n"
       ,progname);
    exit(-1);
   }
  wm_hints.initial_state=NormalState;
  wm_hints.input=True;
  wm_hints.icon_pixmap=icon_pixmap;
  wm_hints.flags=StateHint|IconPixmapHint|InputHint;
  class_hints.res_name=progname;
  class_hints.res_class="Basicwin";
  XSetWMProperties(display,window,&windowName,&iconName,
       argv,argc,&size_hints,&wm_hints,&class_hints);
 }
#endif

/* make the buttons 
 quitbutton=XCreateSimpleWindow(display,window,
    6,0,40,20,2,BlackPixel(display,screen),
    darkcolor);
 pausebutton=XCreateSimpleWindow(display,window,
    56,0,48,20,2,BlackPixel(display,screen),
    darkcolor);
 algobutton=XCreateSimpleWindow(display,window,
    8,55,64,20,2,BlackPixel(display,screen),
    darkcolor);
 heatwindow=XCreateSimpleWindow(display,window,
    windowwidth-HEATERWIDTH-BOUNDWIDTH-12,0,
    HEATERWIDTH,HEATERHEIGHT-1,2,BlackPixel(display,screen),
    lightcolor);

 boundwindow=XCreateSimpleWindow(display,window,
             windowwidth-BOUNDWIDTH-4,0,BOUNDWIDTH,BOUNDHEIGHT-1,2,
             BlackPixel(display,screen),lightcolor);

 about=XCreateSimpleWindow(display,window,
    0,3*windowheight/5,windowwidth-4,2*windowheight/5-4,2,
    BlackPixel(display,screen),WhitePixel(display,screen));
*/
/* pick the events to look for */
 event_mask=ExposureMask|ButtonPressMask|StructureNotifyMask;
 XSelectInput(display,window,event_mask);
/* XSelectInput(display,about,event_mask);*/
 event_mask=ButtonPressMask; 
/* note that with this simple mask if one just covers a button
it will not get redrawn.  I wonder if anyone will notice?  If I put
the exposuremask in here, things flash irritatingly on being uncovered. */
/* XSelectInput(display,quitbutton,event_mask);
 XSelectInput(display,pausebutton,event_mask);
 XSelectInput(display,algobutton,event_mask);
 XSelectInput(display,heatwindow,event_mask);
 XSelectInput(display,boundwindow,event_mask);*/

/* pick font: 9x15 is supposed to almost always be there */
 if ((font=XLoadQueryFont(display,"9x15"))==NULL)
  {fprintf(stderr,"%s: Cannot open 9x15 font\n",progname);
   exit(-1);
  }
 font_height=font->ascent+font->descent;

/* make graphics contexts: 
      gc for black on white
      gccolor for background and buttons 
      gcr for reverse video 
      gcxor for highlighting */
   
 gc=XCreateGC(display,window,0,NULL);
 XSetFont(display,gc,font->fid);
 XSetForeground(display,gc,BlackPixel(display,screen));
 XSetBackground(display,gc,WhitePixel(display,screen)); 
/*
 gcr=XCreateGC(display,window,0,NULL); 
 XSetFont(display,gcr,font->fid);
 XSetForeground(display,gcr,lightcolor);
 XSetBackground(display,gcr,darkcolor); 

 gccolor=XCreateGC(display,window,0,NULL); 
 XSetFont(display,gccolor,font->fid);
 XSetForeground(display,gccolor,darkcolor);
 XSetBackground(display,gccolor,lightcolor); 

 gcxor=XCreateGC(display,window,0,NULL);
 XSetFont(display,gcxor,font->fid);
 XSetForeground(display,gcxor,
             darkcolor^lightcolor);
 XSetFunction(display,gcxor,GXxor);
*/
/* show the window and buttons */
 XMapWindow(display,window);

 return;
}

