#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "path.h"

void do_pathsampling  ();
void do_cycle         ();
void accumulate_stats ();
void terminate_block  (Stats *,Stats *);
void finalstat        (Stats *); 
void printstat        (Stats *);
int free_check() ;
void hahb();
int flux();

main()
{
  int i,j;
  double x,y;
  vector rtmp;
  
  set_up();
  

  if(sys.freq_graphics) {
    init_graphics();
    for(i=0;i<100;i++) plot_conf();
    sleep(1);
  } 


  
  for(j=1;j<=sys.ncycle1;j++){
    for(i=1;i<=sys.ncycle2;i++){
      if (sys.sim_type==1) {
	do_pathsampling(); 
      } else {
	do_cycle();
      }
      accumulate_stats(); 
      
      if (i%sys.freq_check==0) {
	
      }
      if ((sys.freq_graphics) && (i % sys.freq_graphics == 0) && 
	  (sys.sim_type==1)) plot_conf();
      
   
    }
    
    printf("\n\nBLOCK NR  %d\n\n",j);
    terminate_block(&sys.block_stats,&sys.final_stats);
  }
  printf("\n\nFINAL STATISTICS  %d\n\n",j);
  finalstat(&sys.final_stats);
  confoutput();
  distoutput();
  
    
}

void do_pathsampling()
{
  
  int i,j,iwhich,fix,n,len;
  double en;


  for(i=0;i<sys.nshoot+sys.nrept+sys.ndif;i++) {  
    iwhich = (int)(ran3()*(sys.nshoot+sys.nrept+sys.ndif));
    if (iwhich<sys.nshoot) {
      if (ran3()<0.5) {
	if (shoot_forward())  FORWARD_ACC.acc++;
	FORWARD_ACC.try++;
      } else {
	if (shoot_backward())  BACKWARD_ACC.acc++;
	BACKWARD_ACC.try++;
      } 	
    } else {
      if (iwhich<sys.nshoot+sys.nrept) {
	if (ran3()<0.5) {
	  if ( reptation_left()) REPTLEFT_ACC.acc++;
	  REPTLEFT_ACC.try++;
	} else {
	  if (reptation_right()) REPTRIGHT_ACC.acc++;
	  REPTRIGHT_ACC.try++;
	}
      } else {
	n = ran3()*path.nslices;
	n=100;
	len =0;
	for(j=0;j<n;j++) {
	  if (ran3() <0.5) {
	    if (diffuse_left()) {
	      DIFLEFT_ACC.acc++;
	      len--;
	    }
	    printf("diffusing leftt\n");
	    DIFLEFT_ACC.try++;
	  } else {
	    if (diffuse_right()) {
	      DIFRIGHT_ACC.acc++;
	      len++;
	    }
	    
	    printf("diffusing right\n");
	    DIFRIGHT_ACC.try++;
	  }
          
	}
	len = abs(len);
	update_average(NDIFF,len);
      }
    }
    if (in_stable_state_B(&slice[path.nslices-1])==1) INREGIONB.acc++;
    INREGIONB.try++;
    hahb();
    
  }   
}

void do_cycle()
{
  
  static vector r, rold;
  int i;

  if (sys.sim_type==1) {
    for(i=0;i<path.nslices;i++) {
      verlet(&slice[0]);
    } 
  }

  if (sys.sim_type ==2)
    for(i=0;i<path.nslices;i++) {
      if (metropolis(&slice[0])==1) FORWARD_ACC.acc++ ;
      FORWARD_ACC.try++;
    }
  if (sys.sim_type ==3)
    for(i=0;i<path.nslices;i++) {
      langevin_inertia(&slice[0]);   
    }
  
  
  if (sys.freq_graphics) {
    r.x= slice[0].x;
    r.y= slice[0].y;
    drawline(rold,r);
    rold =r;
  }
  i = slice[0].x*100 + MBIN/2;
  if ((i>=0) &&(i<MBIN)) scr.xdist[i]++;
  i = slice[0].y*100 + MBIN/2;
  if ((i>=0) &&(i<MBIN)) scr.ydist[i]++;
  
}

void accumulate_stats()

{ 
  int i,j,na,nb,nbar,k;
  double en,temp0,tempL,dx,dy,dist2,dist,kin_ener,tana,angle;
 
  if (sys.sim_type==1) {
    na = number_of_slices_in_A();
    nb = number_of_slices_in_B();
    nbar = path.nslices - na  - nb;
    update_average(NSLA,na);
    update_average(NSLB,nb);
    update_average(NSLBAR,nbar);
  }
  

  dx = slice[0].x - path.initial.x;
  dy = slice[0].y - path.initial.y;
  tana = dy/dx;
  angle = atan(tana)*180/PI;
  if (dx<0) angle+=180;
  update_average(BEGIN1,angle);
  dx = slice[path.nslices-1].x - path.final.x;
  dy = slice[path.nslices-1].y - path.final.y;
  tana = dy/dx;
  angle = atan(tana)*180/PI;
  if (dx<0) angle+=180;
  update_average(END1,angle);
  
  k = (int)(angle) +90;
  if (k<MBIN) scr.endpointdist[k]++;

  path.tot_ener =path.kin_ener=path.energy =0;
  for(i=0;i<path.nslices;i++) {
    en =energy(&slice[i]);
    scr.energy[i] += en;
    scr.energy2[i] += en*en;
    path.energy    += en;
    kin_ener = 0.5*(slice[i].vx*slice[i].vx + slice[i].vy*slice[i].vy);
    scr.kin_ener[i] += kin_ener;
    scr.kin_ener2[i] += kin_ener*kin_ener;
    path.kin_ener += kin_ener;
    en += kin_ener;
    scr.tot_ener[i] += en;
    scr.tot_ener2[i] += en*en;
    path.tot_ener += en;

  } 
  scr.fcount++;




  temp0 = slice[0].vx*slice[0].vx + slice[0].vy*slice[0].vy;
  tempL = slice[path.nslices-1].vx*slice[path.nslices-1].vx + 
           slice[path.nslices-1].vy*slice[path.nslices-1].vy;
 
  POTENERGY.now = path.energy;
  KIN_ENER.now  = path.kin_ener;
  TOT_ENER.now  = path.tot_ener;
  TEMP.now      = temp0;
  TEMP_L.now    = tempL;
  /*  BLIP.now   = flux();*/

  for (i=0;i<NSTAT;i++) {
    sys.block_stats.aver[i].sum   += sys.block_stats.aver[i].now;
    sys.block_stats.aver[i].sumsq += sys.block_stats.aver[i].now*sys.block_stats.aver[i].now;
    sys.block_stats.aver[i].n++;
   }
}

void terminate_block(Stats *psb, Stats *psav)
     
{
  int i;
    
  for (i=0;i<NSTAT;i++) {
    psb->aver[i].sum   /= sys.ncycle2;
    psb->aver[i].sumsq = sqrt(psb->aver[i].sumsq /sys.ncycle2
             -  psb->aver[i].sum*  psb->aver[i].sum);
  }  
  for (i=0;i<NSHOOTAV;i++) {
    psb->shoot[i].sum   /=  psb->shoot[i].n ;
    psb->shoot[i].sumsq = sqrt(psb->shoot[i].sumsq / psb->shoot[i].n
             -  psb->shoot[i].sum*  psb->shoot[i].sum);
  } 
   
  for (i=0;i<NACC;i++) 
    psb->mcacc[i].ratio = (double)  psb->mcacc[i].acc/ psb->mcacc[i].try;
   
  printstat(psb);

  for (i=0;i<NSTAT;i++) {
    psav->aver[i].sum  += psb->aver[i].sum  ;
    psav->aver[i].sumsq  += psb->aver[i].sum*psb->aver[i].sum  ;
    psb->aver[i].sum    =0;
    psb->aver[i].sumsq  =0;
    psb->aver[i].now    =0;
  }
  for (i=0;i<NSHOOTAV;i++) {
    psav->shoot[i].sum    += psb->shoot[i].sum  ;
    psav->shoot[i].sumsq  += psb->shoot[i].sum*psb->shoot[i].sum  ;
    psb->shoot[i].sum    =0;
    psb->shoot[i].sumsq  =0;
    psb->shoot[i].now    =0;
    psb->shoot[i].n      =0;
  }
 

  for (i=0;i<NACC;i++) {
    psav->mcacc[i].acc += psb->mcacc[i].acc;
    psav->mcacc[i].try += psb->mcacc[i].try;
    psb->mcacc[i].acc =0;
    psb->mcacc[i].try =0;
  }

}


void finalstat(Stats *psav)


{
  int i;

  for (i=0;i<NSTAT;i++) {
    psav->aver[i].sum   /=sys. ncycle1;
    psav->aver[i].sumsq = sqrt(psav->aver[i].sumsq /sys.ncycle1
             -  psav->aver[i].sum*  psav->aver[i].sum);
  }  
  for (i=0;i<NSHOOTAV;i++) {
    psav->shoot[i].sum   /=sys. ncycle1;
    psav->shoot[i].sumsq = sqrt(psav->shoot[i].sumsq /sys.ncycle1
             -  psav->shoot[i].sum*  psav->shoot[i].sum);
  }  

  for (i=0;i<NACC;i++) 
    psav->mcacc[i].ratio = (double)  psav->mcacc[i].acc/ psav->mcacc[i].try;
  printstat(psav);
}

void printstat(Stats *psav) 

{
  int i;
  printf("\nAcceptances\n");
  for (i=0;i<NACC;i++) { 
    printf("%7d accepted %sout of %7d trial moves, ratio = %g\n", 
           psav->mcacc[i].acc,psav->mcacc[i].name,psav->mcacc[i].try,
           psav->mcacc[i].ratio);
  }
  printf("\nAcceptance averages\n");
  for (i=0;i<NSHOOTAV;i++) { 
    printf("     %s   = %10g +- %7g\n", psav->shoot[i].name,  
           psav->shoot[i].sum, psav->shoot[i].sumsq);
  }  

  printf("\nAverages\n");
  for (i=0;i<NSTAT;i++) { 
    printf("     %s   = %10g +- %7g\n", psav->aver[i].name,  
	    psav->aver[i].sum, psav->aver[i].sumsq);
  }  
  
  fflush(NULL);
 
}



 
void hahb()

{
  int i;

  for(i=0;i<path.nslices;i++) {
    if (in_stable_state_B(&slice[i])==1) scr.hahb[i]++;
  }
  scr.n++;
  return;
}

